--------------------------------------------------------------------------------------------------
-- GLOBALS
--------------------------------------------------------------------------------------------------

JPC_TimerUpdate = nil

JPC_TIMERINTERVAL = 1.50

function JPC_OnLoad() 

JPC_RegEvents()

SlashCmdList["JPCCOMMAND"] = JPC_CmdHandler
SLASH_JPCCOMMAND1 = "/jpc"

JPC_CalcTimer()

if (not Print) then
		setglobal("Print", function(msg, r, g, b, frame, id)
			if (not r) then r = 1.0 end
			if (not g) then g = 1.0 end
			if (not b) then b = 1.0 end
			if (not frame) then frame = DEFAULT_CHAT_FRAME end
			if (frame) then
				if (not id) then
					frame:AddMessage(msg,r,g,b)
				else
					frame:AddMessage(msg,r,g,b,id)
				end
			end
		end)
	end

end

function JPC_OnUpdate(arg1)

	local elapsed = arg1
	
	if (not JPC_TimerUpdate) then
			JPC_TimerUpdate = 0
	else
		if (elapsed) then
			JPC_TimerUpdate = JPC_TimerUpdate - elapsed;
		end
	end
		
	if (JPC_TimerUpdate <= 0) then
		JPC_CalcTimer()
	end
	
	-- Restore the timer update timer
	JPC_TimerUpdate = JPC_TIMERINTERVAL
end

function JPC_CalcTimer()

	local JPC_Day = (1163566800 - time()) /60 /60 /24
	local JPC_Hr = mod((1163566800 - time()) /60 /60,24)
	local JPC_Min = mod((1163566800 - time()) /60,60)
	local JPC_Secs = mod((1163566800 - time()),60)

	if (JPC_Day ~= 1) then
	
		JPC_Day_Title = " days "
	
	else

		JPC_Day_Title = " day "

	end

	if (JPC_Hr ~= 1) then
	
		JPC_Hr_Title = " hours "
		
	else

		JPC_Hr_Title = " hour "

	end

	if (JPC_Min ~= 1) then
	
		JPC_Min_Title = " minutes "
	
	else

			JPC_Min_Title = " minute "

	end

	if (JPC_Secs ~= 1) then
	
		JPC_Secs_Title = " seconds "
	
	else

		JPC_Secs_Title = " second "

	end

	JPC_Counter:SetText("|c00FFFFFF" .. format("%d",JPC_Day) .. JPC_Day_Title .. format("%d",JPC_Hr) .. JPC_Hr_Title .. format("%d",JPC_Min) .. JPC_Min_Title .. format("%d",JPC_Secs) .. JPC_Secs_Title);
	
	JPC_LastUpdate:SetText("Last Updated: " .. date())


end

function JPC_CmdHandler(msg)


	msg = string.lower(msg)
	local command = string.find (msg, "(%w+) ([%w%.]+)")

	if ((not command) and msg) then
		command = msg
	end
	
	if (command) then
		command = string.lower(command);
		if (command == "show") then
			
			JPC_Frame:Show()
			Print("Jarek's Pally Countdown Timer is now shown.  Type  /jpc hide  to hide how much of a newb Jarek really is. :)")
			
		elseif (command == "hide") then
		
			JPC_Frame:Hide()
			Print("Jarek's Pally Countdown Timer is now hidden.  Type  /jpc show  to view how much of a newb Jarek really is. :)")

		elseif (command == "update") then
		
			JPC_CalcTimer()
			
		else
			
			Print("Jarek's Pally Countdown Timer: [jpc]")
			Print("  /jpc [show | hide] - show/hide Jarek's Pally Countdown Timer")
			Print("  /jpc update - update Jarek's Pally Countdown Timer")
			
		end
	end	

end

function JPC_RegEvents()
	this:RegisterEvent("VARIABLES_LOADED");
end